.\" Copyright (C) 1993, 1994, 1995 by Joerg Wunsch, Dresden
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR(S) ``AS IS'' AND ANY EXPRESS
.\" OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR(S) BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
.\" STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
.\" IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd September 16, 1993
.Os
.Dt FDFORMAT 1
.Sh NAME
.Nm fdformat
.Nd format floppy disks
.Sh SYNOPSIS
.Nm fdformat
.Op Fl q
.Op Fl v | Fl n
.Op Fl f Ar capacity
.Op Fl c Ar cyls
.Op Fl s Ar secs
.Op Fl h Ar heads
.br
.Op Fl r Ar rate
.Op Fl g Ar gap3len
.Op Fl i Ar intleave
.Op Fl S Ar secshft
.Op Fl F Ar fillbyte
.Op Fl t Ar steps_per_track
.Ar device_name
.Sh DESCRIPTION
.Nm Fdformat
formats a floppy disk at device
.Ar device_name .
.Ar Device_name
should be a character device; it may be given either with a full path
name of a raw device node for a floppy disk drive
.Pq e.\ g. Pa /dev/rfd0 ,
or default name in an abbreviated form
.Pq e.\ g. Em fd0 .
In the latter case, the name is constructed by prepending
.Pa /dev/r
and appending a
.Em .capacity
to the
.Ar device_name .
Note that any geometry constraints of the device node
.Pq minor device number
are meaningless, since they're overridden by
.Nm fdformat .
.Pp
The options are as follows:
.Bl -tag -width 10n -offset indent
.It Fl q
Suppress any normal output from the command, and don't ask the
user for a confirmation whether to format the floppy disk at
.Ar device_name .
.It Fl f Ar capacity
The normal way to specify the desired formatting parameters.
.Ar Capacity
is the number of kilobytes to format. Valid choices are 360, 720, 800, 820,
1200, 1440, 1480 or 1720.
.It Fl n
Don't verify floppy after formatting.
.It Fl v
Don't format, verify only.
.It Fl c Ar cyls
Number of cylinders: 40 or 80.
.It Fl s Ar secs
Number of sectors per track: 9, 10, 15 or 18.
.It Fl h Ar heads
Number of floppy heads: 1 or 2.
.It Fl r Ar rate
Data rate: 250, 300 or 500 kbps.
.It Fl g Ar gap3len
Gap length.
.It Fl i Ar intleave
Interleave factor.
.It Fl S Ar secshft
Sector size: 0=128, 1=256, 2=512 bytes.
.It Fl F Ar fillbyte
Fill byte.
.It Fl t Ar steps_per_track
Number of steps per track.
An alternate method to specify the geometry data to write to the floppy disk.
.El

If the
.Fl q
flag has not been specified, the user is asked for a confirmation
of the intended formatting process. In order to continue, an answer
of
.Dq y
must be given.
.Pp
Note that
.Nm
does only perform low-level formatting.  In case you wish to create
a file system on the medium, see the commands
.Xr newfs 8
for an
.Em ufs
file system, or
.Xr mkdosfs 1
or
.Xr newfs_msdos 8
for an
.Em MS-DOS (FAT)
file system.
.Sh DIAGNOSTICS
Unless
.Fl q
has been specified, a single letter is printed to standard output
to inform the user about the progress of work.
First, an
.Sq Em F
is printed when the track(s) is being formatted, then a
.Sq Em V
while it's being verified, and if an error has been detected, it
will finally change to
.Sq Em E .
.Pp
An exit status of 0 is returned upon successful operation. Exit status
1 is returned on any errors during floppy formatting, and an exit status
of 2 reflects invalid arguments given to the program (along with an
appropriate information written to diagnostic output).
.Sh SEE ALSO
.Xr mkdosfs 1 ,
.Xr fdc 4 ,
.Xr newfs 8 ,
.Xr newfs_msdos 8
.Sh HISTORY
.Nm Fdformat
has been developed for 386BSD 0.1
and upgraded to the new
.Xr fdc 4
floppy disk driver. It later became part of the
.Fx 1.1
system.
.Sh AUTHORS
The program has been contributed by
.if n Joerg Wunsch,
.if t J\(:org Wunsch,
Dresden, with changes by
.An Serge Vakulenko
and
.An Andrey A. Chernov ,
Moscow.
